# -*- coding: utf-8 -*-

import logger
import xbmcaddon
import re
import urllib2
import xbmcgui
import xbmcplugin
import sys
import urllib
import unicodedata
from datetime import datetime, timedelta


addon = xbmcaddon.Addon()
addonname = addon.getAddonInfo('name')

     
def getSetting(settingName):
    setting=xbmcaddon.Addon().getSetting(settingName)
        
    return setting


    
    
def getUrl2(url, referer):
    try:
        from urllib.request import Request, urlopen  # Python 3
    except:
        from urllib2 import Request, urlopen  # Python 2

    req = Request(url)
    req.add_header('Referer', referer)
    req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; de; rv:1.9.1.5) Gecko/20091102 Firefox/3.5.5')
    f = urlopen(req)
    data = f.read()
    f.close()    
    return data

 
    
def getUrl(url):
    #logger.debug(url)

    f=urllib2.urlopen(url)
    data=f.read()
    f.close()

    return data

def findall(pattern, searText, flags):
    #logger.debug("findall - pattern: {0}".format(pattern))

    try:

        return re.findall(pattern, searText,flags)

    except Exception as e:
        logger.debug(str(e))
        return None

def addItemMenu(label, thumbnail, url, IsPlayable = 'false', isFolder= True):

    handle = int(sys.argv[1])

    logger.debug("addItemMenu - label:{0}, thumbnail: {1}, url: {2}, IsPlayable: {3}, isFolder: {4}".format(label,thumbnail,url,IsPlayable,isFolder))

    li= xbmcgui.ListItem(label=label, thumbnailImage=thumbnail)
    li.setProperty('IsPlayable', IsPlayable)

    xbmcplugin.addDirectoryItem(handle, listitem = li, url = url, isFolder = isFolder)

def build_url(query):

    base_url = sys.argv[0]

    return base_url + '?' + urllib.urlencode(query)

def strip_accents(text):
    """
    Strip accents from input String.

    :param text: The input string.
    :type text: String.

    :returns: The processed String.
    :rtype: String.
    """
    try:
        text = unicode(text, 'utf-8')
    except NameError: # unicode is a default on python 3 
        pass
    text = unicodedata.normalize('NFD', text)
    text = text.encode('ascii', 'ignore')
    text = text.decode("utf-8")
    return str(text)
    
def text_to_id(text, separate_caracter):
    """
    Convert input text to id.

    :param text: The input string.
    :type text: String.

    :returns: The processed String.
    :rtype: String.
    """
  #  text = text.lower()
    if text[-1]==' ':           # sometimes last character of title is by mistake written with a blank on the website, this will be deleted
        text = text[:-1]
    if separate_caracter == 'space': 
        separate_caracter = ' '
    elif separate_caracter == 'guion':
        separate_caracter = '-'
    text = strip_accents(text.lower())
    text = text.lower()
    text = re.sub(' ', separate_caracter, text)       #    text = re.sub('[ ]+', '_', text
    text = re.sub('[^0-9a-zA-Z_-]', '', text)
    return text

def text_to_upper_and_URL(text):
    """
    Convert input text to uppercase and convert special characters to unreadable gibberish for URLs
    
    :param text: The input string
    :type text: String
    
    :returns: The processed String
    :rtype: String
    """
    text = unicode(text, 'utf-8')
    text = text.upper()
    text = text.encode('utf-8')
    text = text.replace("Ó", "%C3%93")
    text = text.replace("Á", "%C3%81")
    text = text.replace("Ú", "%C3%9A")
    text = text.replace(" ", "%20")
    text = text.replace("Ñ", "%C3%91")
    text = text.replace("ñ", "%C3%B1")
    text = text.replace("á", "%C3%A1")
    text = text.replace("é", "%C3%A9")
    text = text.replace("í", "%C3%AD")
    text = text.replace("ó", "%C3%B3")
    text = text.replace("ú", "%C3%BA")
    text = text.replace("¡", "%C2%A1")
    text = text.replace("¿", "%C2%BF")
    text = text.replace("É", "%C3%89")
    text = text.replace("Í", "%C3%8D")
    return text
    

def fecha_to_date(text):
    actual_date = datetime.today()
    actual_weekday = actual_date.weekday()
    if text=='hoy': 
        return actual_date.date().isoformat()
    elif text=='ayer':
        return((actual_date - timedelta(days=1)).date().isoformat())
    elif text=='pasado viernes':
        given_weekday = 4
        delta = (actual_date.weekday() + 6 - given_weekday) % 7 + 1
        return (actual_date - timedelta(days=delta)).date().isoformat()
    elif text=='pasado jueves':
        given_weekday = 3
        delta = (actual_date.weekday() + 6 - given_weekday) % 7 + 1
        return (actual_date - timedelta(days=delta)).date().isoformat()
    elif text=='pasado miércoles':            
        given_weekday = 2
        delta = (actual_date.weekday() + 6 - given_weekday) % 7 + 1
        return (actual_date - timedelta(days=delta)).date().isoformat()
    elif text=='pasado martes':
        given_weekday = 1
        delta = (actual_date.weekday() + 6 - given_weekday) % 7 + 1
        return (actual_date - timedelta(days=delta)).date().isoformat()
    elif text=='pasado lunes':
        given_weekday = 0
        delta = (actual_date.weekday() + 6 - given_weekday) % 7 + 1
        return (actual_date - timedelta(days=delta)).date().isoformat()
    elif text=='pasado domingo':
        given_weekday = 6
        delta = (actual_date.weekday() + 6 - given_weekday) % 7 + 1
        return (actual_date - timedelta(days=delta)).date().isoformat()
    elif text=='pasado sábado':
        given_weekday = 5        
        delta = (actual_date.weekday() + 6 - given_weekday) % 7 + 1
        return (actual_date - timedelta(days=delta)).date().isoformat()
    else: 
        mes = {"ene" : "01", "feb" : "02", "mar" : "03", "abr" : "04", "may" : "05", "jun" : "06", "jul" : "07", "ago" : "08", "sep" : "09", "oct" : "10", "nov" : "11", "dic" : "12"}
        temp = text.split(" ")
        fecha = temp[2] + "-" + mes[temp[1]] + "-" + temp[0]
        return fecha
    
    
    #if all(x.isalpha() or x.isspace() for x in text):
       # return text
 
"""
def get_sec(time_str):
    xbmcgui.Dialog().ok(addonname, time_str)
    h, m, s = time_str.split(':')
    return int(h) * 3600 + int(m) * 60 + int(s)
 
"""
 
def get_sec(s):
    l = map(int, s.split(':')) # l = list(map(int, s.split(':'))) in Python 3.x
    return str(sum(n * sec for n, sec in zip(l[::-1], (1, 60, 3600))))
    
    
